/*
 * ds3231.h
 *
 *  Created on: 02-12-2017
 *      Author: MR
 */

#ifndef DS3231_H_
#define DS3231_H_


 #include <avr/io.h>



 typedef union {
	uint8_t bytes[8];
	struct {
		uint8_t ss;
		uint8_t mm;
		uint8_t hh;
		uint8_t dayofweek;
		uint8_t day;
		uint8_t month;
		uint8_t year;
		uint16_t next_day;
	};
} TDATETIME;

  TDATETIME datetime;

#define DS3231_ADDR 0xD0

uint8_t dec2bcd(uint8_t dec);
uint8_t bcd2dec(uint8_t bcd);

void DS3231_init( void );
void DS3231_get_datetime( TDATETIME * dt );

void TIME_CORRECTION_EVENT(TDATETIME * dt);

void DS3231_set_time( uint8_t hh, uint8_t mm, uint8_t ss );
void DS3231_set_date( uint8_t year, uint8_t month, uint8_t day, uint8_t dayofweek );

void DS3231_show_time( TDATETIME * dt );
void DS3231_show_date( TDATETIME * dt );

uint16_t day_of_year(TDATETIME * dt);

void INT_init(void);
#endif /* DS3231_H_ */
